## ycmd 0+20230103+gitf53e7ac+ds

=== requirements.txt ===
bottle   >= 0.12.18
regex    >= 2020.2.20
jedi     >= 0.16.0
watchdog >= 0.10.2
