=== debian/changelog ===
ycmd (0+20230103+gitf53e7ac+ds-1ubuntu1) lunar; urgency=medium

  * Add patch to fix test with Go1.20 (LP: #2012909)

 -- Shengjing Zhu <shengjing.zhu@canonical.com>  Mon, 27 Mar 2023 17:09:04 +0800
