=== debian/control ===
Source: ycmd
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: David Kalnischkies <donkult@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
               dh-python,
               libabsl-dev,
               libclang-dev (>= 1:9.0),
               libgtest-dev,
               libgmock-dev,
               libwhereami-dev,
               pybind11-dev (>= 2.3.0),
               python3-dev,
               python3-regex,
               unicode-data (>= 13.0.0),
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://ycm-core.github.io/ycmd/
Vcs-Git: https://salsa.debian.org/debian/ycmd.git
Vcs-Browser: https://salsa.debian.org/debian/ycmd

Package: ycmd
Architecture: any
Depends: python3-bottle,
         python3-frozendict,
         python3-future,
         python3-jedi (>= 0.16.0),
         python3-watchdog,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: libclang-common-${misc:Clang-Ver}-dev, vim-youcompleteme
Suggests: ccls, clangd, fortran-language-server, gopls, node-typescript
Provides: ycmd-core-version (= ${misc:Core-Ver}), ycmd-core-version (= 47)
Description: code-completion & comprehension server
 ycmd is a server that provides APIs for code-completion and other
 code-comprehension use-cases like semantic GoTo commands (and others). For
 certain filetypes, ycmd can also provide diagnostic errors and warnings.
