=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: ycmd
 Section: devel
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: David Kalnischkies <donkult@debian.org>
+Maintainer: David Kalnischkies <donkult@debian.org>
 Build-Depends: cmake,
                debhelper-compat (= 13),
                dh-python,
@@ -15,7 +14,7 @@
                python3-dev,
                python3-regex,
                unicode-data (>= 13.0.0),
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Rules-Requires-Root: no
 Homepage: https://ycm-core.github.io/ycmd/
 Vcs-Git: https://salsa.debian.org/debian/ycmd.git
@@ -32,7 +31,7 @@
          ${python3:Depends},
          ${shlibs:Depends}
 Recommends: libclang-common-${misc:Clang-Ver}-dev, vim-youcompleteme
-Suggests: ccls, clangd, fortran-language-server, gopls, node-typescript
+Suggests: ccls, clangd, fortran-language-server, godot3, gopls, node-typescript
 Provides: ycmd-core-version (= ${misc:Core-Ver}), ycmd-core-version (= 47)
 Description: code-completion & comprehension server
  ycmd is a server that provides APIs for code-completion and other
