=== examples/requirements.txt ===
requests>=2.5.1
httpie>=0.5.0
