=== ycmd/tests/python/testdata/goto/requirements.txt ===
# required so jedi understands this is the project root for absolute imports
