=== debian/changelog ===
ycmd (0+20231230+git9e43034+ds-2build4) noble; urgency=medium

  * No-change rebuild against libabsl t64.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Thu, 11 Apr 2024 03:25:32 -0500

ycmd (0+20231230+git9e43034+ds-2build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 19:40:57 +1100

ycmd (0+20231230+git9e43034+ds-2build2) noble; urgency=medium

  * No-change rebuild against libabsl t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 16 Mar 2024 18:09:44 +0100

ycmd (0+20231230+git9e43034+ds-2build1) noble; urgency=medium

  * No-change rebuild for python3.12 t64.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 02 Mar 2024 21:16:01 +0100
