=== debian/watch ===
version=4
opts="mode=git, pgpmode=none, date=%Y%m%d, pretty=0+%cd+git%h, repacksuffix=+ds, dversionmangle=auto" \
https://github.com/ycm-core/ycmd \
HEAD debian uupdate
