=== debian/control ===
--- 
+++ 
@@ -22,17 +22,14 @@
 
 Package: ycmd
 Architecture: any
-Depends: python3-bottle,
-         python3-frozendict,
-         python3-future,
-         python3-jedi (>= 0.16.0),
+Depends: python3-jedi (>= 0.16.0),
          python3-watchdog,
          ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
-Recommends: libclang-common-${misc:Clang-Ver}-dev, vim-youcompleteme
-Suggests: ccls, clangd, fortran-language-server, godot3, gopls, node-typescript
-Provides: ycmd-core-version (= ${misc:Core-Ver}), ycmd-core-version (= 47)
+Recommends: libclang-common-${ycmd:Clang-Ver}-dev, vim-youcompleteme
+Suggests: ccls, clangd, dh-debputy (>= 0.1.22.3~), fortran-language-server, godot3, gopls, node-typescript
+Provides: ycmd-core-version (= ${ycmd:Core-Ver}), ycmd-core-version (= 48)
 Description: code-completion & comprehension server
  ycmd is a server that provides APIs for code-completion and other
  code-comprehension use-cases like semantic GoTo commands (and others). For
